<?php
/**
 * Product
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi PIM.
 *
 * PIM
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\PimClient\Dto;

use \ArrayAccess;
use \Ensi\PimClient\ObjectSerializer;

/**
 * Product Class Doc Comment
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Product implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Product';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'main_image' => 'string',
        'external_id' => 'string',
        'category_id' => 'int',
        'brand_id' => 'int',
        'name' => 'string',
        'code' => 'string',
        'description' => 'string',
        'type' => 'int',
        'allow_publish' => 'bool',
        'vendor_code' => 'string',
        'barcode' => 'string',
        'weight' => 'float',
        'weight_gross' => 'float',
        'length' => 'float',
        'width' => 'float',
        'height' => 'float',
        'is_adult' => 'bool',
        'brand' => '\Ensi\PimClient\Dto\Brand',
        'category' => '\Ensi\PimClient\Dto\Category',
        'images' => '\Ensi\PimClient\Dto\ProductImage[]',
        'attributes' => '\Ensi\PimClient\Dto\ProductAttributeValue[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'main_image' => null,
        'external_id' => null,
        'category_id' => null,
        'brand_id' => null,
        'name' => null,
        'code' => null,
        'description' => null,
        'type' => null,
        'allow_publish' => null,
        'vendor_code' => null,
        'barcode' => null,
        'weight' => null,
        'weight_gross' => null,
        'length' => null,
        'width' => null,
        'height' => null,
        'is_adult' => null,
        'brand' => null,
        'category' => null,
        'images' => null,
        'attributes' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'created_at' => false,
        'updated_at' => false,
        'main_image' => true,
        'external_id' => true,
        'category_id' => true,
        'brand_id' => true,
        'name' => false,
        'code' => true,
        'description' => true,
        'type' => false,
        'allow_publish' => false,
        'vendor_code' => true,
        'barcode' => true,
        'weight' => true,
        'weight_gross' => true,
        'length' => true,
        'width' => true,
        'height' => true,
        'is_adult' => true,
        'brand' => false,
        'category' => false,
        'images' => false,
        'attributes' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'main_image' => 'main_image',
        'external_id' => 'external_id',
        'category_id' => 'category_id',
        'brand_id' => 'brand_id',
        'name' => 'name',
        'code' => 'code',
        'description' => 'description',
        'type' => 'type',
        'allow_publish' => 'allow_publish',
        'vendor_code' => 'vendor_code',
        'barcode' => 'barcode',
        'weight' => 'weight',
        'weight_gross' => 'weight_gross',
        'length' => 'length',
        'width' => 'width',
        'height' => 'height',
        'is_adult' => 'is_adult',
        'brand' => 'brand',
        'category' => 'category',
        'images' => 'images',
        'attributes' => 'attributes'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'main_image' => 'setMainImage',
        'external_id' => 'setExternalId',
        'category_id' => 'setCategoryId',
        'brand_id' => 'setBrandId',
        'name' => 'setName',
        'code' => 'setCode',
        'description' => 'setDescription',
        'type' => 'setType',
        'allow_publish' => 'setAllowPublish',
        'vendor_code' => 'setVendorCode',
        'barcode' => 'setBarcode',
        'weight' => 'setWeight',
        'weight_gross' => 'setWeightGross',
        'length' => 'setLength',
        'width' => 'setWidth',
        'height' => 'setHeight',
        'is_adult' => 'setIsAdult',
        'brand' => 'setBrand',
        'category' => 'setCategory',
        'images' => 'setImages',
        'attributes' => 'setAttributes'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'main_image' => 'getMainImage',
        'external_id' => 'getExternalId',
        'category_id' => 'getCategoryId',
        'brand_id' => 'getBrandId',
        'name' => 'getName',
        'code' => 'getCode',
        'description' => 'getDescription',
        'type' => 'getType',
        'allow_publish' => 'getAllowPublish',
        'vendor_code' => 'getVendorCode',
        'barcode' => 'getBarcode',
        'weight' => 'getWeight',
        'weight_gross' => 'getWeightGross',
        'length' => 'getLength',
        'width' => 'getWidth',
        'height' => 'getHeight',
        'is_adult' => 'getIsAdult',
        'brand' => 'getBrand',
        'category' => 'getCategory',
        'images' => 'getImages',
        'attributes' => 'getAttributes'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('main_image', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('category_id', $data, null);
        $this->setIfExists('brand_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('description', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('allow_publish', $data, null);
        $this->setIfExists('vendor_code', $data, null);
        $this->setIfExists('barcode', $data, null);
        $this->setIfExists('weight', $data, null);
        $this->setIfExists('weight_gross', $data, null);
        $this->setIfExists('length', $data, null);
        $this->setIfExists('width', $data, null);
        $this->setIfExists('height', $data, null);
        $this->setIfExists('is_adult', $data, null);
        $this->setIfExists('brand', $data, null);
        $this->setIfExists('category', $data, null);
        $this->setIfExists('images', $data, null);
        $this->setIfExists('attributes', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        if ($this->container['main_image'] === null) {
            $invalidProperties[] = "'main_image' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор товара
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets main_image
     *
     * @return string
     */
    public function getMainImage()
    {
        return $this->container['main_image'];
    }

    /**
     * Sets main_image
     *
     * @param string $main_image URL основной картинки
     *
     * @return $this
     */
    public function setMainImage($main_image)
    {

        if (is_null($main_image)) {
            array_push($this->openAPINullablesSetToNull, 'main_image');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('main_image', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['main_image'] = $main_image;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string|null $external_id Код товара
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {

        if (is_null($external_id)) {
            array_push($this->openAPINullablesSetToNull, 'external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets category_id
     *
     * @return int|null
     */
    public function getCategoryId()
    {
        return $this->container['category_id'];
    }

    /**
     * Sets category_id
     *
     * @param int|null $category_id Идентификатор категории
     *
     * @return $this
     */
    public function setCategoryId($category_id)
    {

        if (is_null($category_id)) {
            array_push($this->openAPINullablesSetToNull, 'category_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('category_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['category_id'] = $category_id;

        return $this;
    }

    /**
     * Gets brand_id
     *
     * @return int|null
     */
    public function getBrandId()
    {
        return $this->container['brand_id'];
    }

    /**
     * Sets brand_id
     *
     * @param int|null $brand_id Идентификатор бренда
     *
     * @return $this
     */
    public function setBrandId($brand_id)
    {

        if (is_null($brand_id)) {
            array_push($this->openAPINullablesSetToNull, 'brand_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('brand_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['brand_id'] = $brand_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название товара
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string|null
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string|null $code Код товара (выводится в URL)
     *
     * @return $this
     */
    public function setCode($code)
    {

        if (is_null($code)) {
            array_push($this->openAPINullablesSetToNull, 'code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description Описание товара
     *
     * @return $this
     */
    public function setDescription($description)
    {

        if (is_null($description)) {
            array_push($this->openAPINullablesSetToNull, 'description');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('description', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int|null $type Тип товара из ProductTypeEnum
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets allow_publish
     *
     * @return bool|null
     */
    public function getAllowPublish()
    {
        return $this->container['allow_publish'];
    }

    /**
     * Sets allow_publish
     *
     * @param bool|null $allow_publish Публикация разрешена
     *
     * @return $this
     */
    public function setAllowPublish($allow_publish)
    {


        /*if (is_null($allow_publish)) {
            throw new \InvalidArgumentException('non-nullable allow_publish cannot be null');
        }*/
        $this->container['allow_publish'] = $allow_publish;

        return $this;
    }

    /**
     * Gets vendor_code
     *
     * @return string|null
     */
    public function getVendorCode()
    {
        return $this->container['vendor_code'];
    }

    /**
     * Sets vendor_code
     *
     * @param string|null $vendor_code Артикул
     *
     * @return $this
     */
    public function setVendorCode($vendor_code)
    {

        if (is_null($vendor_code)) {
            array_push($this->openAPINullablesSetToNull, 'vendor_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('vendor_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['vendor_code'] = $vendor_code;

        return $this;
    }

    /**
     * Gets barcode
     *
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->container['barcode'];
    }

    /**
     * Sets barcode
     *
     * @param string|null $barcode Штрихкод (EAN)
     *
     * @return $this
     */
    public function setBarcode($barcode)
    {

        if (is_null($barcode)) {
            array_push($this->openAPINullablesSetToNull, 'barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['barcode'] = $barcode;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return float|null
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param float|null $weight Масса нетто, кг
     *
     * @return $this
     */
    public function setWeight($weight)
    {

        if (is_null($weight)) {
            array_push($this->openAPINullablesSetToNull, 'weight');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets weight_gross
     *
     * @return float|null
     */
    public function getWeightGross()
    {
        return $this->container['weight_gross'];
    }

    /**
     * Sets weight_gross
     *
     * @param float|null $weight_gross Масса брутто, г
     *
     * @return $this
     */
    public function setWeightGross($weight_gross)
    {

        if (is_null($weight_gross)) {
            array_push($this->openAPINullablesSetToNull, 'weight_gross');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight_gross', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight_gross'] = $weight_gross;

        return $this;
    }

    /**
     * Gets length
     *
     * @return float|null
     */
    public function getLength()
    {
        return $this->container['length'];
    }

    /**
     * Sets length
     *
     * @param float|null $length Длина, мм
     *
     * @return $this
     */
    public function setLength($length)
    {

        if (is_null($length)) {
            array_push($this->openAPINullablesSetToNull, 'length');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('length', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['length'] = $length;

        return $this;
    }

    /**
     * Gets width
     *
     * @return float|null
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param float|null $width Ширина, мм
     *
     * @return $this
     */
    public function setWidth($width)
    {

        if (is_null($width)) {
            array_push($this->openAPINullablesSetToNull, 'width');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('width', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets height
     *
     * @return float|null
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param float|null $height Высота, мм
     *
     * @return $this
     */
    public function setHeight($height)
    {

        if (is_null($height)) {
            array_push($this->openAPINullablesSetToNull, 'height');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('height', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets is_adult
     *
     * @return bool|null
     */
    public function getIsAdult()
    {
        return $this->container['is_adult'];
    }

    /**
     * Sets is_adult
     *
     * @param bool|null $is_adult Товар 18+
     *
     * @return $this
     */
    public function setIsAdult($is_adult)
    {

        if (is_null($is_adult)) {
            array_push($this->openAPINullablesSetToNull, 'is_adult');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_adult', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_adult'] = $is_adult;

        return $this;
    }

    /**
     * Gets brand
     *
     * @return \Ensi\PimClient\Dto\Brand|null
     */
    public function getBrand()
    {
        return $this->container['brand'];
    }

    /**
     * Sets brand
     *
     * @param \Ensi\PimClient\Dto\Brand|null $brand brand
     *
     * @return $this
     */
    public function setBrand($brand)
    {


        /*if (is_null($brand)) {
            throw new \InvalidArgumentException('non-nullable brand cannot be null');
        }*/
        $this->container['brand'] = $brand;

        return $this;
    }

    /**
     * Gets category
     *
     * @return \Ensi\PimClient\Dto\Category|null
     */
    public function getCategory()
    {
        return $this->container['category'];
    }

    /**
     * Sets category
     *
     * @param \Ensi\PimClient\Dto\Category|null $category category
     *
     * @return $this
     */
    public function setCategory($category)
    {


        /*if (is_null($category)) {
            throw new \InvalidArgumentException('non-nullable category cannot be null');
        }*/
        $this->container['category'] = $category;

        return $this;
    }

    /**
     * Gets images
     *
     * @return \Ensi\PimClient\Dto\ProductImage[]|null
     */
    public function getImages()
    {
        return $this->container['images'];
    }

    /**
     * Sets images
     *
     * @param \Ensi\PimClient\Dto\ProductImage[]|null $images images
     *
     * @return $this
     */
    public function setImages($images)
    {


        /*if (is_null($images)) {
            throw new \InvalidArgumentException('non-nullable images cannot be null');
        }*/
        $this->container['images'] = $images;

        return $this;
    }

    /**
     * Gets attributes
     *
     * @return \Ensi\PimClient\Dto\ProductAttributeValue[]|null
     */
    public function getAttributes()
    {
        return $this->container['attributes'];
    }

    /**
     * Sets attributes
     *
     * @param \Ensi\PimClient\Dto\ProductAttributeValue[]|null $attributes attributes
     *
     * @return $this
     */
    public function setAttributes($attributes)
    {


        /*if (is_null($attributes)) {
            throw new \InvalidArgumentException('non-nullable attributes cannot be null');
        }*/
        $this->container['attributes'] = $attributes;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


